import java.util.Scanner;

public class Geenid2 {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int a = scanner.nextInt();
        scanner.nextLine();
        String A = scanner.nextLine();
        int b = scanner.nextInt();
        scanner.nextLine();
        String B = scanner.nextLine();
        System.out.println(SmithWaterman(a, b, A, B));
    }

    public static int SmithWaterman(int n, int m, String s, String t)
    {
        int[][] dp = new int[n + 1][m + 1];
        for (int i = 0; i <= n; i++) {
            for (int j = 0; j <= m; j++) {
                dp[i][j] = 0;
            }
        }

        int vas = 0;

        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= m; j++) {
                int sc = -3; // ei lange kokku
                if (s.charAt(i-1) == t.charAt(j-1)) {
                    sc = 3; // langeb kokku
                }
                dp[i][j] = Math.max(Math.max(dp[i - 1][j] - 2, dp[i][j - 1] - 2), Math.max(0, dp[i - 1][j - 1] + sc));
                vas = Math.max(vas, dp[i][j]);
            }
        }
        return vas;
    }
}
