import java.util.Scanner;

public class Palk {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int pikkus = scanner.nextInt();
        int loikeid = scanner.nextInt();

        int[] loikekohad = new int[loikeid+4];

        for (int i = 0; i < loikeid; i++) {
            loikekohad[i + 1] = scanner.nextInt();
        }

        loikekohad[0] = 0; //alguspunkt
        loikekohad[loikeid+1] = pikkus; //lpp-punkt

        System.out.println(loika(pikkus, loikeid, loikekohad));
        pikkus = scanner.nextInt();
    }

    static int loika(int pikkus, int loikeid, int[] loikekohad) {

        int[][] dp = new int[loikeid + 4][loikeid + 4];
        for (int i = 0; i < loikeid + 4; i++) {
            for (int j = 0; j < loikeid + 4; j++) {
                dp[i][j] = 2147483647;
            }
        }

        for (int i = 0; i <= loikeid + 1; i++) {
            dp[i][i] = 0;
            dp[i][i + 1] = 0;
            dp[i][i + 2] = loikekohad[i + 2] - loikekohad[i];
        }

        for (int k = 3; k <= loikeid + 1; k++) {
            for (int i = 0; i <= loikeid + 1 - k; i++) {
                for (int j = i + 1; j <= i + k - 1; j++) {
                    if ((dp[i][j] + dp[j][i+k] + loikekohad[i+k] - loikekohad[i]) < dp[i][i+k]) {
                        dp[i][i+k] = dp[i][j] + dp[j][i+k] + loikekohad[i+k] - loikekohad[i];
                    }
                }
            }
        }

        return dp[0][loikeid+1];
    }
}
