import java.util.ArrayList;
import java.util.Scanner;

public class DTW {

    static int MAXINT = 2147483647;

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int m = scanner.nextInt();
        ArrayList<Integer> s = new ArrayList<>();
        for (int i = 0; i < m; i++) {
            s.add(scanner.nextInt());
        }
        int n = scanner.nextInt();
        ArrayList<Integer> t = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            t.add(scanner.nextInt());
        }

        System.out.println(DTW(m, n, s, t));
    }

    static int kaugus(int a, int b) {
        return Math.abs(a - b);
    }

    static int DTW(int n, int m, ArrayList<Integer> s, ArrayList<Integer> t)
    {
        int[][] dp = new int[n+1][m+1];

        for (int i = 0; i <= n; i++) {
            for (int j = 0; j <= m; j++) {
                dp[i][j] = MAXINT;
            }
        }

        dp[0][0] = 0;

        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= m; j++) {
                dp[i][j] = Math.min(Math.min(dp[i - 1][j], dp[i][j - 1]), dp[i - 1][j - 1])
                        + kaugus(s.get(i - 1), t.get(j - 1));
            }
        }
        return dp[n][m];
    }
}
